#include <stdio.h>
#include <stdlib.h>
#include "./inc/BasepairMan.h"
/*
 * IndexCompare
 *
 * The sort function of Indices of base-pairs
*/
int IndexCompare(BpIndex *a, BpIndex *b){
	if(a -> score1 > b -> score1 || a -> score1 == b -> score1 && a -> score2 < b -> score2) return(1);
	else				 return(-1);
}


/*
 * SortBasepair
 *
 * The function takes the array of base-pairs and the number of base-pairs as input
 * Then it calls the buildin function 'qsort' to sort the base-pairs
*/
void SortBasepair(int *pairs, int numPairs){
	int	i, j;
	BpIndex	*index;
	int	*pairHolder;

	// put the base-pair information into the array Index
	index = (BpIndex *) calloc(numPairs, sizeof(BpIndex));
	pairHolder = (int *) calloc(6 * numPairs, sizeof(int));
	for(i = 0; i < numPairs; i ++)	{
		for(j = 0; j < 6; j ++)	{
			pairHolder[6 * i + j] = pairs[6 * i + j];
		}
		index[i].position = i;
		index[i].score1 = pairs[6 * i];
		index[i].score2 = pairs[6 * i + 3];
	}

	// sort the Index
	qsort(index, numPairs, sizeof(BpIndex), (void *) IndexCompare);

	// reorder the base-pairs according to the sorted Index
	for(i = 0; i < numPairs; i ++)	{
		for(j = 0; j < 6; j ++)	{
			pairHolder[6 * i + j] = pairs[6 * index[i].position + j];
		}
	}
	for(i = 0; i < numPairs; i ++)	{
		for(j = 0; j < 6; j ++)	{
			pairs[6 * i + j] = pairHolder[6 * i + j];
		}
	}
	free((void *) index);
	free((void *) pairHolder);
}


