/*
 * AddLevel
 *
 * The input is the level we are adding, index of the pair, uparray, sizeuparray, and the array recording each pair's level
 * AddLevel is a function called by BuildLevels
 * It recursively addes pairs into different array, according to their enclosing relationship
 * The result is recorded in array 'label'
*/
void AddLevel(int level, int index, int **uparray, int *sizeuparray, int *label){
	/*add all conflicting stacks to the next level*/
	int	i, j, k;
	int	maxlevel;
	
	/*if current stack is not in the last level, put it in the last level*/
	if(level > label[index])	{
		label[index] = level;
	}
	/*put conflicting stacks in the next level*/
	level ++;
	for(i = 0; i < sizeuparray[index]; i ++)	{
		/*recursively add conflicting stacks*/
		AddLevel(level, uparray[index][i], uparray, sizeuparray, label);
	}
	level --;
	return;
}

/*
 * BuildLevels
 *
 * The input is pairs (actually I think I can remove it), number of pairs, downarray size, uparray, uparray size, array storing pairs levelwise
 * and finally the size of each level
 * BuildLevels builds levels according to their enclosing relationship
 * The number of levels is returned
*/
int BuildLevels(int *pairs, int numPairs, int *sizedownarray, int **uparray, int *sizeuparray, int **levelindex, int *sizelevel){
	int	i, j, k;
	int	level;
	/*label indicating each preicted stack belongs to which level*/
	int	*label;

	label = (int *) ckalloc(numPairs * sizeof(int));
	/*if the stack dose not conflicting with any stacks with larger index*/
	for(i = 0; i < numPairs; i ++)	{
		if(sizedownarray[i] == 0)	{
			/*levels added to label; label indicates each base-pair belongs to which level*/
			AddLevel(0, i, uparray, sizeuparray, label);
		}
	}
	
	/*copy the base-pairs according to label into levelindex*/
	for(i = 0; i < numPairs; i ++)	{
		/*adding information to levelindex*/
		levelindex[label[i]][sizelevel[label[i]] ++] = i;
	}

	/*finds how many levels are created*/
	level = 0;
	for(i = 0; i < numPairs; i ++)	{
		if(sizelevel[i] == 0)	{
			/*record how many levels are here*/
			level = i;
			break;
		}
	}
	free((void *) label);
	/*if there are no levels*/
	if(level == 0)	{
		/*then put each stack in one level*/
		level = numPairs;
	}
	return(level);
}


