#include <stdio.h>
#include <stdlib.h>
#include "./inc/Parameter.h"
/*
 * Global variables used in this file
 *
 * GAPST: penalty for gap start
 * GAPET: penalty for gap extension
 * total_nuc: total number of nucleotide representation
 * na_name: the hash of different nucleotide representation
 * W: the weight function of match and mismatch
*/
static int HARDPENG = 65530;
static int HARDPENH = 65530;
static int GAPST = 3;
static int GAPET = 5;
static double BonusSameG = 3.0;
static double BonusSameH = 4.0;
static double BonusStacking = 1.0;
static double PENMissMotif = 2.0;
static double PENMissTarget = 1.0;
static double PENStacking = 200.0;		// the penalty for stacking effect violation
static double weight1 = 0.2;			// the weight for the sequence similarity in the hairpin loop region
static double weight2 = 0.2;			// the weight for the sequence similarity in the base-pair region
static double weight3 = 0.8;			// the weight for the base-pair similarity

void SetScore(char p, double v){
	extern int GAPST; 
	extern int GAPET;
	extern double PENMissMotif; 
	extern double PENMissTarget; 
	extern double BonusSameG;
	extern double BonusSameH;
	extern double weight1; 
	extern double weight2; 
	extern double weight3; 
	extern int HARDPENG;
	extern int HARDPENH;
	switch(p){
		case 's':
			GAPST = (int) v;
			break;
		case 'e':
			GAPET = (int) v;
			break;
		case 'g':
			HARDPENG = (int) v;
			break;
		case 'h':
			HARDPENH = (int) v;
			break;
		case 'k':
			BonusSameG = v;
			break;
		case 'y':
			BonusStacking = v;
			break;
		case 'l':
			BonusSameH = v;
			break;
		case 'u':
			PENMissMotif = v;
			break;
		case 'v':
			PENMissTarget = v;
			break;
		case 'a':
			weight1 = v;
			break;
		case 'b':
			weight2 = v;
			break;
		case 'c':
			weight3 = v;
			break;
		case 'p':
			PENStacking = v;
			break;
		default:
			printf("Invalid option!\n");
			exit(0);
	}
	return;
}

int rHARDPENG(){
	return HARDPENG;
}
int rHARDPENH(){
	return HARDPENH;
}
int rGAPST(){
	return GAPST;
}
int rGAPET(){
	return GAPET;
}
double rBonusSameG(){
	return BonusSameG;
}
double rBonusSameH(){
	return BonusSameH;
}
double rBonusStacking(){
	return BonusStacking;
}
double rPENMissMotif(){
	return PENMissMotif;
}
double rPENMissTarget(){
	return PENMissTarget;
}
double rPENStacking(){
	return PENStacking;
}
double rweight1(){
	return weight1;
}
double rweight2(){
	return weight2;
}
double rweight3(){
	return weight3;
}
