/*
 * BuildArrays
 *
 * The input is pairs, number of pairs, four arrays to store the result (downarray, downarray size, uparray and uparray size)
 * BuildArrays build arrays according to their relative enclosing relationships
 * uparray records the pairs that enclosing the pair
 * downarray records the pairs that enclosed by the pair
*/
void BuildArrays(int *pairs, int num_pairs, int **downarray, int *sizedownarray, int **uparray, int *sizeuparray);

/*
 * BuildLastlist
 *
 * The function takes the base-pair array, downarray , sizedownarray and two arrays for storing results as input
 * The function builds up the list need to be checked in dynamic programming process
 * The function added the base-pairs that are possible positional preceed a base-pair to that base-pair
 * Called or used by function 'CalChainScore'
*/
void BuildLastlist(int *pairs, int *downarray, int sizedownarray, int **lastlist, int *sizelist);

/*
 * BuildLevels
 *
 * The input is pairs (actually I think I can remove it), number of pairs, downarray size, uparray, uparray size, array storing pairs levelwise
 * and finally the size of each level
 * BuildLevels builds levels according to their enclosing relationship
 * The number of levels is returned
*/
int BuildLevels(int *pairs, int numPairs, int *sizedownarray, int **uparray, int *sizeuparray, int **levelindex, int *sizelevel);

/*
 * GetLastList
 *
 * The function retrieves the indices of the base-pairs that have the highest score
 * Note that this function does not consider the base-pairs that are the same as the current base-pair
 * The reason is that this situation has been already considered priori calling this function
 * Separation of the retrieval due to complexity reason
 * The function takes the current base-pair1 index, current base-pair2 index, optimal i index, optimal j index, and an array 
 * for storing output as input
 * The result is finally stored in the array, and no explicit return value
*/
void GetLastlist(int currentIndex1, int currentIndex2, int **ilast, int **jlast, int *index2);
